package eu.mhsl.minecraft.WorldMuseum.worldSelector;

import eu.mhsl.minecraft.WorldMuseum.Main;
import eu.mhsl.minecraft.WorldMuseum.util.BungeeCord;
import org.bukkit.Bukkit;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.event.player.PlayerJoinEvent;

import java.util.Objects;

public class WorldSelectListener implements Listener {
    private void sendPlayerToExit(Player player) {
        BungeeCord.connect(player, Main.instance().getConfig().getString("bungee.returnToServer"));
    }

    @EventHandler
    public void onExit(InventoryCloseEvent event) {
        if(event.getReason().equals(InventoryCloseEvent.Reason.TELEPORT)) return;

        Bukkit.getScheduler().scheduleSyncDelayedTask(
            Main.instance(),
            () -> event.getPlayer().openInventory(WorldSelectInventory.generateInventory()),
            1
        );

        ConfigurationSection bungeeSettings = Main.instance().getConfig().getConfigurationSection("bungee");
        Objects.requireNonNull(bungeeSettings);

        if(!event.getReason().equals(InventoryCloseEvent.Reason.PLAYER)) return;
        if(!(bungeeSettings.getBoolean("enabled", false))) return;
        if(!bungeeSettings.getBoolean("returnOnSelectExit")) return;
        sendPlayerToExit((Player) event.getPlayer());
    }

    @EventHandler
    public void onInteract(InventoryClickEvent event) {
        event.setCancelled(true);

        if(Objects.equals(event.getCurrentItem(), WorldSelectInventory.exitItem()))
            sendPlayerToExit((Player) event.getWhoClicked());

        Main.instance().getWorlds().stream()
            .filter(viewableWorld -> viewableWorld.getItem().equals(event.getCurrentItem()))
            .findFirst()
            .ifPresent(viewableWorld -> viewableWorld.addViewer((Player) event.getWhoClicked()));
    }

    @EventHandler
    public void onJoin(PlayerJoinEvent event) {
        Bukkit.getScheduler().scheduleSyncDelayedTask(
            Main.instance(),
            () -> event.getPlayer().openInventory(
                WorldSelectInventory.generateInventory()
            )
        );
    }
}
